import { TABLE_NAME } from 'src/core/strings/constants/table.constants';
import { Column, Entity, JoinColumn, ManyToOne } from 'typeorm';
import { BaseCoreModel } from 'src/core/modules/data/model/base-core.model';
import { TransactionItemEntity } from '../../domain/entities/transaction-item.entity';
import { TransactionModel } from './transaction.model';

@Entity(TABLE_NAME.TRANSACTION_ITEM)
export class TransactionItemModel
  extends BaseCoreModel<TransactionItemEntity>
  implements TransactionItemEntity
{
  // item data
  @Column('varchar', { name: 'item_id', nullable: true })
  item_id: string;

  @Column('varchar', { name: 'item_name', nullable: true })
  item_name: string;

  @Column('varchar', { name: 'item_type', nullable: true })
  item_type: string;

  @Column('bigint', { name: 'item_price', nullable: true })
  item_price: number;

  // item tenant data
  @Column('varchar', { name: 'item_tenant_id', nullable: true })
  item_tenant_id: string;

  @Column('varchar', { name: 'item_tenant_name', nullable: true })
  item_tenant_name: string;

  @Column('decimal', { name: 'item_tenant_share_margin', nullable: true })
  item_tenant_share_margin: number;

  // calculation data
  @Column('decimal', { name: 'total_price', nullable: true })
  total_price: number;

  @Column('decimal', { name: 'total_hpp', nullable: true })
  total_hpp: number;

  @Column('decimal', { name: 'total_profit', nullable: true })
  total_profit: number;

  @Column('decimal', { name: 'total_share_tenant', nullable: true })
  total_share_tenant: number;

  @Column('int', { name: 'qty', nullable: true })
  qty: number;

  @Column('varchar', { name: 'transaction_id', nullable: true })
  transaction_id: string;
  @ManyToOne(() => TransactionModel, (model) => model.items, {
    onDelete: 'CASCADE',
    onUpdate: 'CASCADE',
  })
  @JoinColumn({ name: 'transaction_id' })
  transaction: TransactionModel;
}
